"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.data = void 0;
const builder_1 = require("../classes/builder");
const utils_1 = require("../classes/utils");
async function Condition(d, c, o) {
    const r = await d.interpreter.parse(c, d.req, d.res, d);
    d.break = !!r?.break;
    d._ = r?._ || d._;
    d.code = o;
    return utils_1.Utils.condition(r.code);
}
async function solve(fn) {
    if (fn.fields) {
        for (let i = 0; i < fn.fields.length; i++) {
            for (let o of fn.fields[i].overs) {
                await solve(o);
                fn.fields[i].value = fn.fields[i].value.replace(o.id, o.total);
                fn.inside = fn.inside?.replace(o.id, o.total);
                fn.total = fn.total.replace(o.id, o.total);
            }
            ;
        }
        ;
    }
}
exports.data = {
    data: new builder_1.FunctionBuilder()
        .setName("while")
        .setValue("description", "Execute a code field while the given condition is met.")
        .setValue("use", "$while[condition;code]")
        .setValue("returns", "void"),
    async code(d) {
        await d.interpreter.resolve_field(d, 0);
        if (!d.func?.fields || d.func.fields.length < 2)
            return utils_1.Utils.Warn('Invalid inside provided in:', d.func.name);
        let cond = d.func.fields[0].value, old_code = d.code;
        await solve(d.func);
        let code = d.func.fields[1].value.unescape();
        while (await Condition(d, cond, old_code)) {
            const r = await d.interpreter.parse(code, d.req, d.res, d);
            d.break = !!r?.break;
            d._ = r?._ || d._;
            d.code = old_code;
        }
    }
};
